#include <stdlib.h>
#include <stdio.h>
#include <strings.h>
#include <GL/glut.h>
#include <math.h>
#include "xgetopt.h"
#include "vector.h"
#include "obj.h"
#include "version.h"

#define MAX_HG_NUM 8000

struct HG_List     *HGL ;
struct PolyObjData *head_obj ;
struct View3D       view3d ;

int     startx ;
int     starty ;
int     hideHGP  =0 ;
int     hideHG   =0 ;
int     hideHead =0 ;
int     hideHeadP=0 ;
int     keystat ;
int     mouse_Button ;
int     alt_stat ;
int     shift_stat ;
int     cntl_stat ;

int     edit_mode ;
char   *edit_mode_list[] = { "Edit HairGuide      ",  "Select HairRoot     " } ;
int     sync_mode ;
char   *sync_mode_list[] = { "Sync=Liner     ",  "Sync=Normal     " } ;
char   *HG_disp_list[]   = { "(Show)="         ,  "(Hide)=" } ;

int     edit_gid  = 0 ;
char    gid_str[] = "GroupID" ;
char   *gid_num[] = {"0","1","2","3","4","5","6","7"} ;

char   *inputhair  ;
char   *input3ds   ;
char   *outputhair ;
char   *outputpov  ;

char   default_inputhair[] = "input.hair"  ;
char   default_input3ds[]  = "input.3ds"   ;
char   default_outputhair[]= "output.hair" ;
char   default_outputpov[] = "output.inc"  ;

GLfloat light0pos[] = {   0, 0,   1.0, 0 };


GLfloat s_ctlpoints[48];
GLfloat s_knots[8] = {0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0};

GLUnurbsObj *theNurb;


struct PolyObjData *read_3ds(char *fname ) ;
struct element_HG   search_HG( struct View3D *view3d, struct HG_List *HGL ) ;
int                 move_HG( struct View3D *view3d, struct HG_List *HGL, int mode ) ;
struct HG_List     *init_HG( int HGmax ) ;
struct element_HG   select_HG( struct View3D *view3d, struct HG_List *HGL, int mode ) ;
int                 selectall_HG( struct View3D *view3d, struct HG_List *HGL, int mode ) ;

int                 search_HR( struct View3D *view3d, struct PolyObjData *Poly) ;
int                 setdraw_HR( struct View3D *view3d, struct PolyObjData *Poly) ;
int                 select_HR( struct View3D *view3d, struct PolyObjData *Poly, int mode) ;
int                 selectall_HR( struct View3D *view3d, struct PolyObjData *Poly, int mode ) ;
int                 selectgid_HG( struct View3D *view3d, struct HG_List *HGL, int gid ) ;
int                 del_HG( struct HG_List *HGL ) ;
int                 gen_HG( struct PolyObjData *Poly, struct HG_List *HGL, int gid ) ;
int                 chg_HGgid( struct PolyObjData *Poly, struct HG_List *HGL, int gid ) ;
int                 write_hair(char *fname, struct HG_List *HGL, struct PolyObjData *obj) ;
struct PolyObjData *read_hair(char *fname, struct HG_List *HGL ) ;
int                 write_pov(char *fname, struct HG_List *HGL, struct PolyObjData *obj) ;
int                 clr_his( struct SelHist *his ) ;
int                 add_HS( struct View3D *view3d ) ;
int                 clr_HS( struct View3D *view3d ) ;


void idle(void)
{
  glutPostRedisplay();
}

void resize(int w, int h)
{
  glViewport(0, 0, w, h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(view3d.fov, (double)view3d.win_w / (double)view3d.win_h, 0.3, 200.0);
  gluLookAt(view3d.v.x, view3d.v.y, view3d.v.z,
	    view3d.c.x, view3d.c.y, view3d.c.z,
	    view3d.u.x, view3d.u.y, view3d.u.z) ;
  glMatrixMode(GL_MODELVIEW);
  view3d.win_w=w ;
  view3d.win_h=h ;
}

void display(void)
{
  int i,j ;
  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glLoadIdentity();
  
  glViewport(0, 0, view3d.win_w, view3d.win_h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(view3d.fov, (double)view3d.win_w / (double)view3d.win_h, 0.3, 200.0);
  gluLookAt(view3d.v.x, view3d.v.y, view3d.v.z,
	    view3d.c.x, view3d.c.y, view3d.c.z,
	    view3d.u.x, view3d.u.y, view3d.u.z) ;
  glMatrixMode(GL_MODELVIEW);
    
  glLoadIdentity();
  glLightfv(GL_LIGHT0, GL_POSITION, light0pos);

  { /*** Draw cursor ***/
    glDisable(GL_LIGHTING);
    glPointSize(8.0);
    glColor3f(1.0, 0.0, 0.0);
    glBegin(GL_POINTS);
    glVertex3f(view3d.cur.x, view3d.cur.y, 0.0) ;
    glEnd();
  }

  glTranslated( view3d.p.x , view3d.p.y , view3d.p.z);
  glRotated( view3d.r.x , 1.0, 0.0, 0.0 );
  glRotated( view3d.r.y , 0.0, 1.0, 0.0 );
  
  /*** Draw hair-surface***/
  if( view3d.hs.n > 0 ){
    int k,l ;
    GLfloat mat_diffuse[] = { 0.5, 0.5, 0.9, 1.0 };
    GLfloat mat_ambient[] = { 0.2,0.2,0.2,1.0 } ;
    
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
    glLightfv(GL_LIGHT0, GL_AMBIENT, mat_ambient ) ;
    glEnable(GL_AUTO_NORMAL);
    glEnable(GL_NORMALIZE);
    
    for( i=0 ; i<view3d.hs.n ; i++ ){
      for( k=0 ; k<2 ; k++ ){
	for( l=0 ; l<12 ; l++ ){
	  s_ctlpoints[ 0 + l] = HGL->HG[view3d.hs.hg1[i]].plist[l+k*9] ;
	  s_ctlpoints[12 + l] = HGL->HG[view3d.hs.hg2[i]].plist[l+k*9] ;
	  s_ctlpoints[24 + l] = HGL->HG[view3d.hs.hg1[i]].plist[l+k*9] ;
	  s_ctlpoints[36 + l] = HGL->HG[view3d.hs.hg2[i]].plist[l+k*9] ;
	}
	gluBeginSurface(theNurb);
	gluNurbsSurface(theNurb, 
			8, s_knots,
			8, s_knots,
			4 * 3,
			3,
			&s_ctlpoints[0], 
			4, 4,
			GL_MAP2_VERTEX_3);
	gluEndSurface(theNurb);
      }
    }
  }

  /*** Draw hair ***/
  if(hideHG==0) {
    glDisable(GL_LIGHTING);
    for( i=0 ; i<HGL->n ; i++ ){
      if( view3d.gp[HGL->HG[i].gid].hide==0 ){
	if( i==(view3d.HGno.n) ){
	  glColor3f(1.0, 0.0, 0.0);
	}else{
	  if( HGL->HG[i].sel!=0 ){
	    glColor3f(0.5, 0.0, 0.0);
	  }else{
	    glColor3f(view3d.gp[HGL->HG[i].gid].lc[0],
		      view3d.gp[HGL->HG[i].gid].lc[1],
		      view3d.gp[HGL->HG[i].gid].lc[2]) ;
	  }
	}
	for( j=0 ; j<((HGL->HG[i].pnum/3)-1)/3 ; j++ ){
	  gluBeginCurve(theNurb);
	  gluNurbsCurve( theNurb,
			 HGL->HG[i].nknot, HGL->HG[i].knots,
			 3,
			 &HGL->HG[i].plist[(j*3)*3],
			 4,
			 GL_MAP1_VERTEX_3) ;
	  gluEndCurve(theNurb);
	}
      }
    }
  }

  /*** Draw hair cntl point ***/
  if(hideHGP==0) {
    glDisable(GL_LIGHTING);
    for( i=0 ; i<HGL->n ; i++ ){
      if( view3d.gp[HGL->HG[i].gid].hide==0 ){
	for( j=0 ; j<HGL->HG[i].pnum ; j+=3 ){
	  if( (j/3)%3==0 ){
	    glPointSize(5.0);
	  }else{
	    glPointSize(3.0);
	  }
	  glBegin(GL_POINTS);
	  if( j==0 ){
	    glColor3f(0.0, 0.0, 1.0);
	  }else{
	    if( i==(view3d.HGno.n) ){
	      glColor3f(1.0, 0.0, 0.0);
	    }else{
	      if( HGL->HG[i].sel!=0 ){
		glColor3f(0.5, 0.0, 0.0);
	      }else{
		glColor3f(view3d.gp[HGL->HG[i].gid].pc[0],
			  view3d.gp[HGL->HG[i].gid].pc[1],
			  view3d.gp[HGL->HG[i].gid].pc[2]) ;
	      }
	    }
	  }
	  glVertex3f(HGL->HG[i].plist[j+0],HGL->HG[i].plist[j+1],HGL->HG[i].plist[j+2]) ;
	  glEnd();
	}
      }
      if( view3d.HGno.n>=0 ){
	if( view3d.gp[HGL->HG[view3d.HGno.n].gid].hide==0 ){
	  int i=view3d.HGno.n ;
	  for( j=0 ; j<HGL->HG[i].pnum ; j+=3 ){
	    if( (j/3)%3==1 ){
	      glBegin(GL_LINES);
	      glColor3f(1.0, 0.0, 0.0);
	      glVertex3fv(&HGL->HG[i].plist[j]);
	      glVertex3fv(&HGL->HG[i].plist[j-3]);
	      glEnd();
	    }else if( (j/3)%3==2 ){
	      glBegin(GL_LINES);
	      glColor3f(1.0, 0.0, 0.0);
	      glVertex3fv(&HGL->HG[i].plist[j]);
	      glVertex3fv(&HGL->HG[i].plist[j+3]);
	      glEnd();
	    }
	  }
	}
      }
    }
  }
    
  /*** Draw head object ***/
  if( hideHead==0 ){
    GLfloat mat_diffuse[] = { 0.7, 0.7, 0.7, 1.0 };
    GLfloat mat_ambient[] = { 0.2,0.2,0.2,1.0 } ;
    
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
    glLightfv(GL_LIGHT0, GL_AMBIENT, mat_ambient ) ;
    glBegin( GL_TRIANGLES ) ;
    for ( j=0 ; j < head_obj->fnum ; j++ ){
      GLdouble vertex[3] ;
      
      glColor3f(1.0, 1.0, 1.0);
      vertex[0]=head_obj->flist[j].normal.x ;
      vertex[1]=head_obj->flist[j].normal.y ;
      vertex[2]=head_obj->flist[j].normal.z ;
      glNormal3dv(vertex);
      vertex[0]=head_obj->plist[head_obj->flist[j].p2].x ;
      vertex[1]=head_obj->plist[head_obj->flist[j].p2].y ;
      vertex[2]=head_obj->plist[head_obj->flist[j].p2].z ;
      glVertex3dv(vertex);
      vertex[0]=head_obj->plist[head_obj->flist[j].p1].x ;
      vertex[1]=head_obj->plist[head_obj->flist[j].p1].y ;
      vertex[2]=head_obj->plist[head_obj->flist[j].p1].z ;
      glVertex3dv(vertex);
      vertex[0]=head_obj->plist[head_obj->flist[j].p0].x ;
      vertex[1]=head_obj->plist[head_obj->flist[j].p0].y ;
      vertex[2]=head_obj->plist[head_obj->flist[j].p0].z ;
      glVertex3dv(vertex);
    }
    glEnd();
  }

  /*** Draw hair root point ***/
  if( hideHeadP==0 ){
    glPointSize(5.0);
    glDisable(GL_LIGHTING);
    glBegin(GL_POINTS);
    for( i=0 ; i<head_obj->pnum ; i++ ){
      if( head_obj->draw[i]==0 ) continue ;
      if( i==(view3d.HRno) ){
	glColor3f(1.0, 0.0, 0.0);
      }else{
	if( head_obj->sel[i]==1 ){
	  glColor3f(0.5, 0.0, 0.0);
	}else{
	  glColor3f(1.0, 1.0, 1.0);
	}
      }
      glVertex3f(head_obj->plist[i].x,head_obj->plist[i].y,head_obj->plist[i].z) ;
    }
    glEnd();
  }

  { /*** Draw EditMode ***/
    int i;
    glLoadIdentity();
    glDisable( GL_LIGHTING );
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    gluOrtho2D( 0.0, 100.0, 0.0, 100.0  );
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    glColor3f(view3d.gp[edit_gid].lc[0], view3d.gp[edit_gid].lc[1], view3d.gp[edit_gid].lc[2]) ;
    glRasterPos2i( 0, 0 );
    
    i=0 ;
    while( edit_mode_list[edit_mode][i]!='\0' ){
      glutBitmapCharacter( GLUT_BITMAP_HELVETICA_18, edit_mode_list[edit_mode][i]) ;
      i++ ;
    }
    
    i=0 ;
    while( sync_mode_list[sync_mode][i]!='\0' ){
      glutBitmapCharacter( GLUT_BITMAP_HELVETICA_18, sync_mode_list[sync_mode][i]) ;
      i++ ;
    }
    
    i=0 ;
    while( gid_str[i]!='\0' ){
      glutBitmapCharacter( GLUT_BITMAP_HELVETICA_18, gid_str[i]) ;
      i++ ;
    }
    i=0 ;
    while( HG_disp_list[view3d.gp[edit_gid].hide][i]!='\0' ){
      glutBitmapCharacter( GLUT_BITMAP_HELVETICA_18, HG_disp_list[view3d.gp[edit_gid].hide][i]) ;
      i++ ;
    }

    
    glutBitmapCharacter( GLUT_BITMAP_HELVETICA_18, gid_num[edit_gid][0]) ;
  }

  
  //glFlush();
  glutSwapBuffers(); /** for DoubleBuffer **/

}  

void key(unsigned char key , int x , int y)
{
  switch( key ){
  case 'r' :
    view3d.v.x=0.0   ;  view3d.v.y=0.0   ;  view3d.v.z=5.0   ;
    view3d.c.x=0.0   ;  view3d.c.y=0.0   ;  view3d.c.z=0.0   ;
    view3d.u.x=0.0   ;  view3d.u.y=1.0   ;  view3d.u.z=0.0   ;
    view3d.r.x=0.0   ;  view3d.r.y=0.0   ;  view3d.r.z=0.0   ;
    view3d.p.x=0.0   ;  view3d.p.y=0.0   ;  view3d.p.z=0.0   ;
    view3d.scale=1.0 ;
    view3d.cur.x=0.0 ;  view3d.cur.y=0.0 ;  view3d.cur.z=0.0 ;
    view3d.sta.x=0.0 ;  view3d.sta.y=0.0 ;  view3d.sta.z=0.0 ;
    view3d.HGno.n =-1 ;
    setdraw_HR( &view3d, head_obj ) ;
    glutPostRedisplay();
    break ;
  case 's' :
    hideHGP = (hideHGP+1)%2 ;
    glutPostRedisplay();
    break ;
  case 'S' :
    hideHG = (hideHG+1)%2 ;
    glutPostRedisplay();
    break ;
  case 'h' :
    hideHead   = (hideHead+1)%2 ;
    glutPostRedisplay();
    break ;
  case 'H' :
    hideHeadP  = (hideHeadP+1)%2 ;
    glutPostRedisplay();
    break ;
  case ' ' :
    if(        edit_mode==0 ){
      selectall_HG( &view3d, HGL, 2 ) ;
    } else if( edit_mode==1 ){
      selectall_HR( &view3d, head_obj, 2 ) ;
    }
    glutPostRedisplay();
    break ;
  case 'a' :
    if(        edit_mode==0 ){
      selectall_HG( &view3d, HGL, 1 ) ;
    } else if( edit_mode==1 ){
      selectall_HR( &view3d, head_obj, 1 ) ;
    }
    glutPostRedisplay();
    break ;
  case 'A' :
    if(        edit_mode==0 ){
      selectgid_HG( &view3d, HGL, edit_gid ) ;
    } else if( edit_mode==1 ){
    }
    glutPostRedisplay();
    break ;
  case '1' :
    edit_gid=0 ;
    glutPostRedisplay();
    break ;
  case '!' :
    view3d.gp[0].hide = (view3d.gp[0].hide+1)%2 ;
    glutPostRedisplay();
    break ;
  case '2' :
    edit_gid=1 ;
    glutPostRedisplay();
    break ;
  case '"' :
    view3d.gp[1].hide = (view3d.gp[1].hide+1)%2 ;
    glutPostRedisplay();
    break ;
  case '3' :
    edit_gid=2 ;
    glutPostRedisplay();
    break ;
  case '#' :
    view3d.gp[2].hide = (view3d.gp[2].hide+1)%2 ;
    glutPostRedisplay();
    break ;
  case '4' :
    edit_gid=3 ;
    glutPostRedisplay();
    break ;
  case '$' :
    view3d.gp[3].hide = (view3d.gp[3].hide+1)%2 ;
    glutPostRedisplay();
    break ;
  case 'm' :
    edit_mode=(edit_mode+1)%2 ;
    glutPostRedisplay();
    break ;
  case 'n' :
    sync_mode=(sync_mode+1)%2 ;
    glutPostRedisplay();
    break ;
  case 127 : /* DEL */
    if(        edit_mode==0 ){
      del_HG( HGL ) ;
      clr_HS( &view3d ) ;
    } else if( edit_mode==1 ){
    }
    glutPostRedisplay();
    break ;
  case 'x' :
    if(        edit_mode==0 ){
      clr_HS( &view3d ) ;
    } else if( edit_mode==1 ){
    }
    glutPostRedisplay();
    break ;
  case 'g' :
    if(        edit_mode==0 ){
    } else if( edit_mode==1 ){
      gen_HG( head_obj, HGL, edit_gid ) ;
    }
    glutPostRedisplay();
    break ;
  case 'o' :
    write_hair(outputhair,HGL,head_obj) ;
    printf("output to file %s\n",outputhair) ;
    break ;
  case 'p' :
    write_pov(outputpov,HGL,head_obj) ;
    printf("output to POVfile %s\n",outputpov) ;
    break ;
  case 'q' :
    exit(0) ;
    break ;
  case 'c' :
    if(        edit_mode==0 ){
      chg_HGgid( head_obj, HGL, edit_gid ) ;
    } else if( edit_mode==1 ){
    }
    glutPostRedisplay();
    break ;
  case 'y' :
    add_HS( &view3d ) ;
    glutPostRedisplay();
    break ;
  default :
    break ;
  }
  //printf("Key = %d\n" , key);
}

void skey(int key , int x , int y)
{

  switch( key ){
  case GLUT_KEY_PAGE_UP :
    break ;
  case GLUT_KEY_PAGE_DOWN :
    break ;
  case 100 : //GULT_KEY_LEFT :
    break ;
  case 102 : //GULT_KEY_RIGHT :
    break ;
  case 101 : //GULT_KEY_UP :
    break ;
  case 103 : //GULT_KEY_DOWN :
    break ;
  default :
    break ;
  }
  //printf("Key = %d\n" , key);
}

void mousebutton(int button, int state, int x, int y)
{
  keystat=glutGetModifiers() ;

  alt_stat  =keystat & GLUT_ACTIVE_ALT ;
  shift_stat=keystat & GLUT_ACTIVE_SHIFT ;
  cntl_stat =keystat & GLUT_ACTIVE_CTRL ;

  if( state==GLUT_DOWN ){
    if( button==GLUT_LEFT_BUTTON ){
      mouse_Button |= 1 ;
    }
    if( button==GLUT_RIGHT_BUTTON ){
      mouse_Button |= 2 ;
    }
  }
  if( state==GLUT_UP ){
    view3d.cur.x =  view3d.v.z*tan(dec2rad(view3d.fov/2.0)) * (startx     -(view3d.win_w/2))/(view3d.win_h/2) ;
    view3d.cur.y = -view3d.v.z*tan(dec2rad(view3d.fov/2.0)) * (starty     -(view3d.win_h/2))/(view3d.win_h/2) ;
    if(       edit_mode==0 ){
      search_HG( &view3d, HGL ) ;
      if( alt_stat==0 && shift_stat==0 && cntl_stat!=0 ){	  
	select_HG( &view3d, HGL, mouse_Button ) ;
      }
    }else if( edit_mode==1 ){
      search_HR( &view3d, head_obj ) ;
      if( alt_stat==0 && shift_stat==0 && cntl_stat==0 ){	  
	select_HR( &view3d, head_obj, mouse_Button ) ;
      }
    }
    if( button==GLUT_LEFT_BUTTON ){
      mouse_Button &= ~(1) ;
    }
    if( button==GLUT_RIGHT_BUTTON ){
      mouse_Button &= ~(2) ;
    }
  }
}

void mousemotion(int x, int y)
{

  alt_stat  =keystat & GLUT_ACTIVE_ALT ;
  shift_stat=keystat & GLUT_ACTIVE_SHIFT ;
  cntl_stat =keystat & GLUT_ACTIVE_CTRL ;

  if( alt_stat!=0 ){
    if(  shift_stat==0 && cntl_stat==0 ){
      view3d.r.y+= startx-x ;
      if( view3d.r.y<0.0   ) view3d.r.y+=360.0 ;
      if( view3d.r.y>360.0 ) view3d.r.y-=360.0 ;
      view3d.r.x-= starty-y ;
      if( view3d.r.x<0.0   ) view3d.r.x+=360.0 ;
      if( view3d.r.x>360.0 ) view3d.r.x-=360.0 ;
      
      startx=x ;
      starty=y ;
      setdraw_HR( &view3d, head_obj ) ;
      glutPostRedisplay();
    }
    
    if( shift_stat==0 && cntl_stat!=0 ){
      view3d.v.z += (starty-y)/10.0 ;
      if( view3d.v.z> 100 ) view3d.v.z= 100 ;
      if( view3d.v.z< 0.0 ) view3d.v.z= 0.0 ;
      startx=x ;
      starty=y ;
      glutPostRedisplay();
    }

    if( shift_stat!=0 && cntl_stat==0 ){
      view3d.p.x -= (startx-x)/20.0 ;
      view3d.p.y += (starty-y)/20.0 ;
      startx=x ;
      starty=y ;
      glutPostRedisplay();
    }
  }else{ // alt_stat==0
    
    view3d.sta.x =  view3d.v.z*tan(dec2rad(view3d.fov/2.0)) * (startx-(view3d.win_w/2))/(view3d.win_h/2) ;
    view3d.sta.y = -view3d.v.z*tan(dec2rad(view3d.fov/2.0)) * (starty-(view3d.win_h/2))/(view3d.win_h/2) ;
    view3d.cur.x =  view3d.v.z*tan(dec2rad(view3d.fov/2.0)) * (x     -(view3d.win_w/2))/(view3d.win_h/2) ;
    view3d.cur.y = -view3d.v.z*tan(dec2rad(view3d.fov/2.0)) * (y     -(view3d.win_h/2))/(view3d.win_h/2) ;
    
    if(       edit_mode==0 ){
      if(       cntl_stat==0 ){
	move_HG( &view3d, HGL, sync_mode ) ;
      }else if( cntl_stat!=0 ){
	search_HG( &view3d, HGL ) ;
	select_HG( &view3d, HGL, mouse_Button ) ;
      }
    }else if( edit_mode==1 ){
      search_HR( &view3d, head_obj ) ;
      select_HR( &view3d, head_obj, mouse_Button ) ;
    }
    
    startx=x ;
    starty=y ;
    glutPostRedisplay();
  }
}

void pmousemotion(int x, int y)
{
  startx=x ;
  starty=y ;
  
  view3d.cur.x =  view3d.v.z*tan(dec2rad(view3d.fov/2.0)) * (x     -(view3d.win_w/2))/(view3d.win_h/2) ;
  view3d.cur.y = -view3d.v.z*tan(dec2rad(view3d.fov/2.0)) * (y     -(view3d.win_h/2))/(view3d.win_h/2) ;
  if(       edit_mode==0 ){
    search_HG( &view3d, HGL ) ;
  }else if( edit_mode==1 ){
    search_HR( &view3d, head_obj ) ;
  }
  //printf("x=%f : y=%f : viewz=%f\n",cur_x,cur_y,viewz) ;
  glutPostRedisplay();
}

void init(void)
{
  GLfloat mat_diffuse[] = { 0.7, 0.7, 0.7, 1.0 };
  GLfloat ambient[] = { 0.2,0.2,0.2,1.0 } ;
  
  glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
  glClearColor(0.0,0.0,1.0,0.5) ;
  glEnable(GL_DEPTH_TEST);
  //  glEnable(GL_CULL_FACE);
  //  glCullFace(GL_BACK);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_AMBIENT, ambient ) ;

  theNurb = gluNewNurbsRenderer();
  gluNurbsProperty(theNurb, GLU_SAMPLING_TOLERANCE, 50.0);
  gluNurbsProperty(theNurb, GLU_DISPLAY_MODE, GLU_FILL);
  //gluNurbsProperty(theNurb, GLU_DISPLAY_MODE, GLU_OUTLINE_POLYGON);
}

void var_init(void)
{
  view3d.fov  =30.0 ;
  view3d.v.x=0.0   ;  view3d.v.y=0.0   ;  view3d.v.z=5.0   ;
  view3d.c.x=0.0   ;  view3d.c.y=0.0   ;  view3d.c.z=0.0   ;
  view3d.u.x=0.0   ;  view3d.u.y=1.0   ;  view3d.u.z=0.0   ;
  view3d.r.x=0.0   ;  view3d.r.y=0.0   ;  view3d.r.z=0.0   ;
  view3d.p.x=0.0   ;  view3d.p.y=0.0   ;  view3d.p.z=0.0   ;
  view3d.cur.x=0.0 ;  view3d.cur.y=0.0 ;  view3d.cur.z=0.0 ;
  view3d.sta.x=0.0 ;  view3d.sta.y=0.0 ;  view3d.sta.z=0.0 ;
  view3d.win_w=480 ;
  view3d.win_h=320 ;
  view3d.id   =0   ;
  view3d.scale=1.0 ;
  view3d.HGno.n=-1 ;
  view3d.HGno.p=-1 ;
  view3d.HRno  =-1 ;
  edit_mode  = 0 ;
  sync_mode  = 0 ;
  edit_gid   = 0 ;
  view3d.gp[0].lc[0]=1.0 ; view3d.gp[0].lc[1]=1.0 ; view3d.gp[0].lc[2]=0.0 ;
  view3d.gp[0].pc[0]=1.0 ; view3d.gp[0].pc[1]=1.0 ; view3d.gp[0].pc[2]=0.0 ;
  view3d.gp[0].hide =0 ;
  view3d.gp[1].lc[0]=0.0 ; view3d.gp[1].lc[1]=1.0 ; view3d.gp[1].lc[2]=0.0 ;
  view3d.gp[1].pc[0]=0.0 ; view3d.gp[1].pc[1]=1.0 ; view3d.gp[1].pc[2]=0.0 ;
  view3d.gp[1].hide =0 ;
  view3d.gp[2].lc[0]=0.0 ; view3d.gp[2].lc[1]=1.0 ; view3d.gp[2].lc[2]=1.0 ;
  view3d.gp[2].pc[0]=0.0 ; view3d.gp[2].pc[1]=1.0 ; view3d.gp[2].pc[2]=1.0 ;
  view3d.gp[2].hide =0 ;
  view3d.gp[3].lc[0]=1.0 ; view3d.gp[3].lc[1]=0.0 ; view3d.gp[3].lc[2]=1.0 ;
  view3d.gp[3].pc[0]=1.0 ; view3d.gp[3].pc[1]=0.0 ; view3d.gp[3].pc[2]=1.0 ;
  view3d.gp[3].hide =0 ;

  clr_his( &view3d.his ) ;
  clr_HS( &view3d ) ;
}

void manprint()
{
  fprintf(stderr,
	  "HairMaker " VERSION " TANE\n"
	  "Usage: hairmaker [-Options]\n"
	  " Options\n"
	  "  -i file or --input-hair=file  : input  hair-format file name\n"
	  "  -3 file or --input-3ds=file   : input  3ds-format  file name\n"
	  "  -o file or --output-hair=file : output hair-format file name\n"
	  "  -p file or --output-pov=file  : output pov-format  file name\n"
	  "  -h      or --help             : Print this message\n"
	  ) ;
}

int parse_opt(struct GETOPT_ARG *args)
{
  int ret ;
  static struct GETOPT_LIST getopt_list[]={
    {"help",               'h',  NONARG, 'h'},
    {"input-3ds",          '3', NEEDARG, '3'},
    {"intpu-hair",         'i', NEEDARG, 'i'},
    {"output-hair",        'o', NEEDARG, 'o'},
    {"output-pov",         'p', NEEDARG, 'p'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  
  inputhair  = NULL ;
  input3ds   = NULL ;
  outputhair = NULL ;
  outputpov  = NULL ;

  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      manprint() ;
      exit(0) ;
      break ;
    case '3' :
      input3ds=(char*)malloc(strlen(xgetopt_val)+1) ;
      strcpy(input3ds,xgetopt_val) ;
      break ;
    case 'i' :
      inputhair=(char*)malloc(strlen(xgetopt_val)+1) ;
      strcpy(inputhair,xgetopt_val) ;
      break ;
    case 'o' :
      outputhair=(char*)malloc(strlen(xgetopt_val)+1) ;
      strcpy(outputhair,xgetopt_val) ;
      break ;
    case 'p' :
      outputpov=(char*)malloc(strlen(xgetopt_val)+1) ;
      strcpy(outputpov,xgetopt_val) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      fprintf(stderr,"Option argument not found.\n") ;
      exit(-1) ;
    case XGETOPT_INVALID_OPTION :
      fprintf(stderr,"Invalid option.\n") ;
      exit(-1) ;
    default :
      fprintf(stderr,"xgetopt internal error\n") ;
      exit(-1) ;
    }
    if( ret==XGETOPT_NOT_OPTION ){
    }
  }
  return(0) ;
}
  

int main(int argc, char *argv[])
{
  int i ;
  struct GETOPT_ARG args ;

  XGETOPT_INIARG(args) ;
  for( i=1 ; i<argc ; i++ ) XGETOPT_ADDARG(args,argv[i]) ;
  if( parse_opt(&args)<0 ) exit(-1) ;
  
  var_init();

  HGL=init_HG(MAX_HG_NUM) ;
  if( HGL==NULL ){
    printf("Can not init HairGuideList\n") ;
  }


  if( input3ds!=NULL ){
    head_obj=read_3ds(input3ds) ;
    if( head_obj==NULL ){
      printf("Can not read 3ds file %s\n",input3ds) ;
      exit(-1) ;
    }else{
      printf("Read 3ds file %s\n",input3ds) ;
    }
  }else{
    if( inputhair==NULL ) inputhair=default_inputhair ;
    head_obj=read_hair(inputhair, HGL ) ;
    if( head_obj==NULL ){
      printf("Can not read hair file %s\n",inputhair) ;
      exit(-1) ;
    }else{
      printf("Read hair file %s\n",inputhair) ;
      printf("Read %d points\n",head_obj->pnum) ;
      printf("Read %d faces\n" ,head_obj->fnum) ;
      printf("Read %d guides\n",HGL->n) ;
    }
  }

  if( outputhair==NULL ) outputhair=default_outputhair ;
  if( outputpov ==NULL ) outputpov =default_outputpov ;

  setdraw_HR( &view3d, head_obj ) ;
  
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE); /** for DoubleBuffer **/
  glutInitWindowSize(view3d.win_w , view3d.win_h);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  //  glutIdleFunc(idle); 
  glutKeyboardFunc(key);
  glutSpecialFunc(skey);
  glutMouseFunc(mousebutton);
  glutMotionFunc(mousemotion);
  glutPassiveMotionFunc(pmousemotion);
  init();

  glutMainLoop();
  
  exit(0) ;
}
